-- 
-- add constraints to validation dictionary
-- 

--
-- SF categories 
--
ALTER TABLE SFCATS ADD UNIQUE (SFCAT);
ALTER TABLE SFCATS ADD FOREIGN KEY (MANDATORY) REFERENCES SFMANENUM (MANDATORY);
DROP INDEX SFCATIDX;
CREATE INDEX SFCATIDX ON SFCATS (SFCAT);

--
-- Tags
--
ALTER TABLE TAGS ADD FOREIGN KEY (SFCAT) REFERENCES SFCATS (SFCAT);
ALTER TABLE TAGS ADD FOREIGN KEY (MANDATORY) REFERENCES TAGMANENUM (MANDATORY);
ALTER TABLE TAGS ADD FOREIGN KEY (VALTYPE) REFERENCES VALTYPENUM (VALTYPE);
DROP INDEX TAGCATIDX;
CREATE INDEX TAGCATIDX ON TAGS (TAGCAT);
DROP INDEX TAGNAMEIDX;
CREATE INDEX TAGNAMEIDX ON TAGS (TAGNAME,SFCAT);

-- 
-- Value enumerations
-- 
ALTER TABLE VALENUMS ADD FOREIGN KEY (SEQ) REFERENCES TAGS (SEQ);
DROP INDEX VALENUMIDX;
CREATE UNIQUE INDEX VALENUMIDX ON VALENUMS (SEQ,VAL);

--
-- Dependent values
--
ALTER TABLE TAGDEPS ADD FOREIGN KEY (MANDATORY) REFERENCES TAGMANENUM (MANDATORY);
ALTER TABLE TAGDEPS ADD FOREIGN KEY (CTLSEQ) REFERENCES TAGS (SEQ);
ALTER TABLE TAGDEPS ADD FOREIGN KEY (SEQ) REFERENCES TAGS (SEQ);

-- 
-- parent-child relationships
-- 
ALTER TABLE TAGRELS ADD FOREIGN KEY (PRNTSEQ) REFERENCES TAGS (SEQ);
ALTER TABLE TAGRELS ADD FOREIGN KEY (CHLDSEQ) REFERENCES TAGS (SEQ);
